<!DOCTYPE html>
<html>

<head>
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.15.3/css/all.min.css" />
  <!-- Popper Development version -->
  <script src="https://cdn.jsdelivr.net/npm/popper.js@1.16.1/dist/umd/popper.min.js"></script>
  <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
  <!-- Import DataTable Library -->
  <!-- Import them style bootstrap cho datatable -->
  <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
  <!-- Import Datatable sau jquery -->
  <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
  <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
</head>
<style>
  label {
    width: 20%;
    margin: 20px 0 20px 100px;
  }

  select {
    width: 30% !important;
    margin: 20px;
  }

  button {
    width: 10%;
    height: 60px;
    margin-top: 10px;
  }
</style>

<body>
  <div class="container">
    <h3 class="text-center">F100-QUẢN TRỊ NGƯỜI DÙNG</h3>
    <div class="row bg-secondary">
      <label class="row-3">Role</label>
      <select class="bg-primary form-control" id="select-role">
        <option value="0">None</option>
      </select>
      <button class="btn btn-success class-5" id="filter-btn">Lọc dữ liệu</button>
    </div>
    <table id="user-table" class="table table-hover table-striped table-bordered">
      <thead class="thead-dark">
        <tr>
          <th scope='col'>STT</th>
          <th scope='col'>Username</th>
          <th scope='col'>First name</th>
          <th scope='col'>Last name</th>
          <th scope='col'>Email</th>
          <th scope='col'>Age</th>
          <th scope='col'>Role</th>
          <th scope='col'>Action</th>
        </tr>
      </thead>
    </table>
  </div>
</body>

<script>
  /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
  const gDATA = ['id', 'username', 'firstname', 'lastname', 'email', 'age', 'roleId', 'action'];
  const gID_COL = 0;
  const gUSER_NAME_COL = 1;
  const gFIRST_NAME_COL = 2;
  const gLAST_NAME_COL = 3;
  const gEMAIL_COL = 4;
  const gAGE_COL = 5;
  const gROLE_ID_COL = 6;
  const gACTION_COL = 7;
  // Mảng gUserObjects là mảng chứa dữ liệu users
  var gUserObjects = [
    {
      id: 2,
      username: "quannv",
      firstname: "Ngo Van",
      lastname: "Quan",
      age: 18,
      email: "quan@gmail.com",
      roleId: 5
    },
    {
      id: 3,
      username: "longdh",
      firstname: "Do Hoang",
      lastname: "Long",
      age: 19,
      email: "long@gmail.com",
      roleId: 8
    },
    {
      id: 4,
      username: "hiendt",
      firstname: "Do Thi",
      lastname: "Hien",
      age: 29,
      email: "hien@gmail.com",
      roleId: 11
    },
    {
      id: 6,
      username: "lanht",
      firstname: "Ho Thi",
      lastname: "Lan",
      age: 27,
      email: "lan@gmail.com",
      roleId: 13
    }
  ];
  // Mảng gRoleObjects là mảng chứa dữ liệu các roles
  var gRoleObjects = [
    {
      roleId: 5,
      roleName: "Admin"
    },
    {
      roleId: 8,
      roleName: "Manager"
    },
    {
      roleId: 11,
      roleName: "Teacher"
    },
    {
      roleId: 13,
      roleName: "Staff"
    }
  ];

  /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */
  $(document).ready(function () {
    onPageLoading();
    $("#filter-btn").on('click', function () {
      onBtnFilterClick();
    })
  })
  /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
  function onPageLoading() {
    renderTable();
    loadToSelectRole();
  }

  function onBtnFilterClick() {
    var vUserFilter = gUserObjects.filter(filterUserBySelect);
    console.log(vUserFilter);

    gStt = 1;
    var vTable = $("#user-table").DataTable();
    vTable.clear();
    vTable.rows.add(vUserFilter);
    vTable.draw();
  }

  function filterUserBySelect(paramObjectElement) {
    return paramObjectElement.roleId == $("#select-role").val();
  }

  function loadToSelectRole() {
    for (var bI = 0; bI < gRoleObjects.length; bI++) {
      $("<option/>", {
        html: gRoleObjects[bI].roleName,
        value: gRoleObjects[bI].roleId
      }).appendTo($("#select-role"));
    }
  }

  function mappingRoleNameByID(paramData, paramType, paramRow) {
    for (let bI = 0; bI < gRoleObjects.length; bI++) {
      const bRoleObjItem = gRoleObjects[bI];
      if (paramData == bRoleObjItem.roleId) {
        return bRoleObjItem.roleName;
      }
    }
  }

  function renderTable() {
    gStt = 1;
    var vTable = $("#user-table").DataTable({
      data: gUserObjects,
      columns: [
        { data: gDATA[gID_COL] },
        { data: gDATA[gUSER_NAME_COL] },
        { data: gDATA[gFIRST_NAME_COL] },
        { data: gDATA[gLAST_NAME_COL] },
        { data: gDATA[gEMAIL_COL] },
        { data: gDATA[gAGE_COL] },
        { data: gDATA[gROLE_ID_COL] },
        { data: gDATA[gACTION_COL] },
      ],
      columnDefs: [
        {
          targets: gID_COL,
          render: () => {
            return gStt++;
          }
        },
        {
          targets: gROLE_ID_COL,
          className: "text-right",
          render: mappingRoleNameByID
        },
        {
          targets: gACTION_COL,
          className: "text-success",
          defaultContent: `
          <button class="btn btn-link" data-toggle="tooltip" data-placement="bottom" title="Dice History"><i class="fas fa-dice text-success"></i></button>
          <button class="btn btn-link" data-toggle="tooltip" data-placement="bottom" title="Dice Present"><i class="fas fa-gift  text-success"></i></button>`
        }
      ]
    })
  }
  /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/

</script>

</html>